entity teller is
   port (m, klok, reset: in bit;
         output: out bit_vector(2 downto 0));
end teller;

architecture behavior of teller is
   type state_type is (S0, S1, S2, S3, S4, S5, S6, S7);
   signal current_state, next_state: state_type;
begin
   combin: process(current_state, m)
   begin
      case current_state is
         when S0 =>
            output <= "000";
            next_state <= S1;
         when S1 =>
            output <= "001";
            if (m = '0') then
               next_state <= S2;
            else
               next_state <= S3;
            end if;
         when S2 =>
            output <= "010";
            if (m = '0') then
               next_state <= S3;
            else
               next_state <= S6;
            end if;
         when S3 =>
            output <= "011";
            if (m = '0') then
               next_state <= S4;
            else
               next_state <= S2;
            end if;
         when S4 =>
            output <= "100";
            if (m = '0') then
               next_state <= S5;
            else
               next_state <= S0;
            end if;
         when S5 =>
            output <= "101";
            if (m = '0') then
               next_state <= S6;
            else
               next_state <= S4;
            end if;
         when S6 =>
            output <= "110";
            next_state <= S7;
         when S7 =>
            output <= "111";
            if (m = '0') then
               next_state <= S0;
            else
               next_state <= S5;
            end if;
      end case;
   end process;
   
   sync: process(klok, reset)
   begin
      if (reset = '1') then
         current_state <= S0;
      elsif (klok'event and klok = '1') then
         current_state <= next_state;
      end if;
   end process;
end behavior;
            
entity teller_tb is
end teller_tb;

architecture test of teller_tb is
--
-- maak hier de code voor de testbench
--
end test;

configuration teller_tb_cfg of teller_tb is
--
-- voeg hier de configuratiecode toe
--
end teller_tb_cfg;


