library IEEE;
use IEEE.std_logic_1164.all;

entity counter is
   port (clk: in std_logic;
         rst: in std_logic;
         val: out integer);
end counter;

architecture behaviour of counter is
   signal tmp: integer;
begin
   val <= tmp;
   lbl1: process(clk, rst, tmp)
   begin
      if (clk'event and clk = '1') then
         if (rst = '1') then
            tmp <= 0;
         elsif (tmp = 9) then
            tmp <= 0;
         else
            tmp <= tmp + 1;
         end if;
      end if;
   end process;
end behaviour;

library IEEE;
use IEEE.std_logic_1164.all;
entity segm_dec is
   port (val: in  std_logic_vector(3 downto 0);
         code: out std_logic_vector(6 downto 0));
end segm_dec;

architecture behaviour of segm_dec is
begin
   lbl1: process (val)
   begin
      if    val = "0000" then code <= "0111111";
      elsif val = "0001" then code <= "0000110";
      elsif val = "0010" then code <= "1011011";
      elsif val = "0011" then code <= "1001111";
      elsif val = "0100" then code <= "1100110";
      elsif val = "0101" then code <= "1101101";
      elsif val = "0110" then code <= "1111101";
      elsif val = "0111" then code <= "0000111";
      elsif val = "1000" then code <= "1111111";
      elsif val = "1001" then code <= "1101111";
      end if;
   end process;
end behaviour;

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity cntr_plus_dec is
   port (clk, res: in std_logic;
         code:     out std_logic_vector(6 downto 0));
end cntr_plus_dec;

architecture structural of cntr_plus_dec is
--
-- maak hier een structurele beschrijving van de koppeling van
-- de counter en de segment_decoder
--
end structural;

configuration cntr_plus_dec_orig_cfg of cntr_plus_dec is
--
-- maak hier een beschrijving van de
-- configuratie van het samenstel van de counter en
-- de segment_decoder
--
end cntr_plus_dec_orig_cfg;

library IEEE;
use IEEE.std_logic_1164.all;
entity cntr_plus_dec_tb is
end cntr_plus_dec_tb;

architecture test of cntr_plus_dec_tb is
   component cntr_plus_dec
      port (clk, res: in std_logic;
            code:     out std_logic_vector(6 downto 0));
   end component;
   signal clk, res: std_logic;
   signal code: std_logic_vector(6 downto 0);
begin
   lbl1: cntr_plus_dec port map (clk, res, code);
   clk <= '1' after 500 ns when clk /= '1' else
          '0' after 500 ns;
   res <= '1' after 0 ns,
          '0' after 2 us;
end test;

configuration cntr_plus_dec_tb_cfg of cntr_plus_dec_tb is
   for test
      for all: cntr_plus_dec use configuration work.cntr_plus_dec_orig_cfg ;
      end for;
   end for;
end cntr_plus_dec_tb_cfg;


